/**********************************************************************
 Copyright (c) 2007 Roger Blum, Pascal N�esch and others. All rights reserved.
 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.

 Contributors:
 ...
 **********************************************************************/
package org.datanucleus.store.rdbms.mapping.ao2postgis;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.datanucleus.exceptions.NucleusDataStoreException;
import org.datanucleus.store.mapped.MappedStoreManager;
import org.datanucleus.store.mapped.mapping.JavaTypeMapping;

import com.esri.arcgis.geometry.Polyline;

/**
 * Mapping for a ESRI Polyline object to PostGIS.
 */
public class PolylineRDBMSMapping extends GeometryRDBMSMapping
{
    public PolylineRDBMSMapping(MappedStoreManager storeMgr, JavaTypeMapping mapping)
    {
        super(storeMgr, mapping);
    }

    public Object getObject(Object rs, int exprIndex)
    {
        Polyline value = null;

        try
        {
            byte[] binaryResult = ((ResultSet) rs).getBytes(exprIndex);
            if (!((ResultSet) rs).wasNull() && binaryResult != null)
            {
                value = new Polyline(getFromWkb(binaryResult));
            }
        }
        catch (SQLException e)
        {
            throw new NucleusDataStoreException(failureMessage("getObject", exprIndex, e), e);
        }

        return value;
    }
}